HDU 5355 (构造 dfs剪枝)

来源:互联网 发布:淘宝卖家名字大全 编辑:程序博客网 时间:2024/06/16 17:06

Cake

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)
Total Submission(s): 2759    Accepted Submission(s): 576
Special Judge


Problem Description
There are m soda and today is their birthday. The 1-st soda has prepared n cakes with size 1,2,,n. Now 1-st soda wants to divide the cakes into m parts so that the total size of each part is equal. 

Note that you cannot divide a whole cake into small pieces that is each cake must be complete in the m parts. Each cake must belong to exact one of m parts.
 

Input
There are multiple test cases. The first line of input contains an integer T, indicating the number of test cases. For each test case:

The first contains two integers n and m (1n105,2m10), the number of cakes and the number of soda.
It is guaranteed that the total number of soda in the input doesn’t exceed 1000000. The number of test cases in the input doesn’t exceed 1000.
 

Output
For each test case, output "YES" (without the quotes) if it is possible, otherwise output "NO" in the first line.

If it is possible, then output m lines denoting the m parts. The first number si of i-th line is the number of cakes in i-th part. Then si numbers follow denoting the size of cakes in i-th part. If there are multiple solutions, print any of them.
 

Sample Input
41 25 35 29 3
 

Sample Output
NOYES1 52 1 42 2 3NOYES3 1 5 93 2 6 73 3 4 8
 


题意:将n个数分成m份每份的和相等.

排除显然不可能存在解的情况,直接暴搜竟然过了=.=

和这个题:点击打开链接差不多,剪枝的优化也很类似.

#include <cstdio>#include <cstring>#include <cmath>#include <algorithm>#include <iostream>#include <map>#include <vector>using namespace std;#define maxn 111111long long n, m, sum;int len;int a[maxn];bool vis[maxn];//每个数字是否使用int ans[11][maxn];//每一组的答案int b[maxn];//每一组的长度bool dfs (int pos, int cur, int cnt, int num) {//当前枚举数字的下标 当前数字和 当前数字个数 已经完成num组    if (num == m) {        return 1;    }    if (cur == len) {        b[num] = cnt;        if (dfs (1, 0, 0, num+1)) {            return 1;        }    }    if (pos > n) {        return 0;    }    for (int i = pos; i <= n; i++) {        if (!vis[i] && cur+a[i] <= len) {            vis[i] = 1;            ans[num][cnt] = a[i];            if (dfs (i+1, cur+a[i], cnt+1, num))                return 1;            vis[i] = 0;            if (cur+a[i] == len)                return 0;            if (cur == 0)                return 0;        }    }    return 0;}void solve () {    for (int i = 1; i <= n; i++) {        a[i] = n-i+1;    }    long long pre = n;    memset (vis, 0, sizeof vis);    if (dfs (1, 0, 0, 0)) {        printf ("YES\n");        n = pre;        for (int i = 0; i < m; i++) {            printf ("%d", b[i]);            for (int j = 0; j < b[i]; j++) {                printf (" %d", ans[i][j]);            }            printf ("\n");        }    }    else        printf ("NO\n");}int main () {    //freopen ("in.txt", "r", stdin);    int t;    scanf ("%d", &t);    while (t--) {        scanf ("%lld%lld", &n, &m);        sum = n*(n+1)/2;        if (sum%m != 0 || sum/m < n) {            printf ("NO\n");            continue;        }        len = sum/m;        solve ();    }    return 0;}


0 0